Summary:   Czech recoding module for Apache WWW server
Name:      mod_csacek
Version:   2.1.6
Release:   1
Copyright: GPL
Source:    http://www.csacek.cz/distrib/csacek-%{version}.tar.bz2
Group:     System Environment/Daemons
URL:	   http://www.csacek.cz
Requires:  webserver
Requires:  zlib
PreReq: grep sed perl
BuildRoot: /var/tmp/csacek-root 
Packager: Milan Kerslager <kerslage@linux.cz>

%description 
Module for on-fly encoding changing among various Czech character encodings.
If your Apache WWW server serves in Czech language, use this module.

%prep
%setup -q -n csacek-%{version}

%build
autoconf configure.in > configure
chmod a+x configure
./configure --with-target=Apache \
            --with-templatedir=/var/www/html/csacek \
            --with-apxs
make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/lib/apache
install -m 755 -s mod_csacek.so $RPM_BUILD_ROOT/usr/lib/apache

# manual 
mkdir -p $RPM_BUILD_ROOT/var/www/html/manual/mod/mod_csacek
cp -a doc/* $RPM_BUILD_ROOT/var/www/html/manual/mod/mod_csacek

# stranka s nabidkou prekodovani
mkdir -p $RPM_BUILD_ROOT/var/www/html/csacek
install -m 644 templates/*.html $RPM_BUILD_ROOT/var/www/html/csacek

%clean
rm -rf $RPM_BUILD_ROOT

%post
DEBUG=0
SLEEP=1
TMP=/tmp/csacek-install
if [ ! -e $TMP  ]; then
  CONFFOUND=0
  for HTCONF in /etc/httpd/conf/httpd.conf /etc/httpd/httpd.conf /etc/httpd.conf; do
    if [ -f $HTCONF -a $CONFFOUND = 0 ]; then
      echo "Pridavam mod_csacek do $HTCONF ..."

      if egrep -qi '^[[:blank:]]*#[[:blank:]]*loadmodule[[:blank:]]+.*mod_csacek\.so' $HTCONF; then
        sed 's/^\([[:blank:]]*#[[:blank:]]*\)\([Ll]oad[Mm]odule[[:blank:]]\+csacek_module\)/\2/' < $HTCONF > $TMP
        mv -f $TMP $HTCONF
      fi

      if egrep -qi '^[[:blank:]]*#[[:blank:]]*addmodule[[:blank:]]+mod_csacek\.c' $HTCONF; then
        sed 's/^\([[:blank:]]*#[[:blank:]]*\)\([Aa]dd[Mm]odule[[:blank:]]\+mod_csacek\.c\)/\2/' < $HTCONF > $TMP
        mv -f $TMP $HTCONF
      fi

      if ! egrep -qi '^[[:blank:]]*loadmodule[[:blank:]]+.*mod_csacek\.so' $HTCONF; then
        perl -pi -e '
if( /^\s*#?\s*loadmodule\s+/i ) {
    $inPos1 = 1 if $inPos1 != 2;
} else {
    if( $inPos1 == 1 ) {
        $inPos1 = 2;
        printf "LoadModule csacek_module\t/usr/lib/apache/mod_csacek.so\n";
    }
}
      ' $HTCONF
      fi

      if ! egrep -qi '^[[:blank:]]*addmodule[[:blank:]]+mod_csacek' $HTCONF; then
        perl -pi -e '
if( /^\s*#?\s*addmodule\s+/i ) {
    $inPos2 = 1 if $inPos2 != 2;
} else {
    if( $inPos2 == 1 ) {
        $inPos2 = 2;
        printf "AddModule mod_csacek.c\n";
    }
}
      ' $HTCONF
      fi

      if ! egrep -qi "^[[:blank:]]*<[[:blank:]]*ifmodule[[:blank:]]+mod_csacek" $HTCONF; then
        echo "<IfModule mod_csacek.c>" >>$HTCONF
        echo "    csacekEngine on" >> $HTCONF
        echo "    csacekDefaultCharset iso-8859-2" >> $HTCONF
        echo "</IfModule>" >>$HTCONF
      fi

      CONFFOUND=1
    fi
  done
  echo "... hotovo, nezapomente restartovat Apache."
else
  echo "mod_csacek nebyl (re)aktivovan, protoze existuje"
  echo "$TMP. (Potencialni nebezpeci tmp-exploit.)"
fi

%postun
if [ "$1" = 0 ]; then
	TMP=/tmp/csacek-install
	DEBUG=0
	SLEEP=1
	if [ ! -e $TMP  ]; then

		##
		## Apache library loading statements
		##
		CONFFOUND=0
		for HTCONF in /etc/httpd/conf/httpd.conf /etc/httpd/httpd.conf /etc/httpd.conf; do
			if [ -f $HTCONF -a $CONFFOUND = 0 ]; then

				# Comment csacek library statements
				sed 's/^\([[:blank:]]*[Ll]oad[Mm]odule[[:blank:]]*csacek_module\)/#\1/' < $HTCONF > $TMP
				mv -f $TMP $HTCONF
				sed 's/^\([[:blank:]]*[Aa]dd[Mm]odule[[:blank:]]*mod_csacek.c\)/#\1/' < $HTCONF > $TMP
				mv -f $TMP $HTCONF

				if [ $DEBUG = 1 ]; then
					echo "step 1 - $HTCONF"
					sleep $SLEEP
				fi

				CONFFOUND=1
			fi
		done

		rm -f $TMP
	else
		echo "mod_csacek nebyl deaktivovan, protoze existuje"
		echo "$TMP. (Potencialni nebezpeci tmp-exploit.)"
	fi
fi

%files 
%defattr(-,root,root)
/usr/lib/apache/mod_csacek.so
/var/www/html/manual/mod/mod_csacek
/var/www/html/csacek
%doc README CHANGES COPYING INSTALL

%changelog
* Sun May 13 2001 Milan Kerslager <kerslage@linux.cz>
- updated to csacek-2.1.6
- patch for APXS removed, PreReq for perl, sed and grep added
- cestina.html is now integral part of mod_csacek and is
  under the directory /var/www/html/csacek
- rebuild for 7.1

* Thu Nov 16 2000 Ivo Panacek <ivop@regionet.cz>
- build under RedHat 7.0
  so docs moved to /var/www/html

* Fri Nov 03 2000 Ivo Panacek <ivop@regionet.cz>
- uprava skriptu post (mate radi Perl ?)

* Mon Oct 16 2000 Ivo Panacek <ivop@regionet.cz>
- kompilace proti Apache 1.3.14
- pridan testovaci soubor cestina.html
- uprava pro preklad s apxs
- patch konfiguracnich souboru Apache pri instalaci a pred odinstalovanim
  (vypujceno z mod_php4)
- mirne vylepsene popisky (Summary, Group a description)

* Tue Apr 11 2000 Radek Vybiral <Radek.Vybiral@vsb.cz>
- verze 2.1.4 a kompilace na Apache 3.0.12 s podporou EAPI

* Thu Mar 23 2000 Radek Vybiral <Radek.Vybiral@vsb.cz>
- patch na chybu pri stahovani dokumentu

* Wed Mar 01 2000 Radek Vybiral <Radek.Vybiral@vsb.cz>
- zdrojova verze 2.1.3 
- uprava volani configure skriptu podle nove verze
- zmenen nazev SPEC souboru

* Thu Jan 27 2000 Radek Vybiral <Radek.Vybiral@vsb.cz>
- zdrojova verze 2.1.2

* Sun Dec 05 1999 Radek Vybiral <Radek.Vybiral@vsb.cz>
- zdrojova verze 2.1.1 a oprava na Makefile.in

* Mon Oct 25 1999 Radek Vybiral <Radek.Vybiral@vsb.cz>
- pridany patche pro verzi 2.1.0

* Fri Sep 24 1999 Radek Vybiral <Radek.Vybiral@vsb.cz>
- upraveno pro verzi 2.1.0

* Mon Sep 21 1999 Radek Vybiral <Radek.Vybiral@vsb.cz>
- prvni zverejnena RPM verze, byl jsem prvni :)

